UPHG_initDone = false;
UPHG_currentIndex = 1;

--/////////////////////////////////////////////////////////

function UPHealGroups_OnLoad(this)

	SlashCmdList["UPHEALGROUPS"] = UPHealGroups_SlashCommandHandler;
	SLASH_UPHEALGROUPS1 = "/uphg";
	SLASH_UPHEALGROUPS2 = "/upheal";
	SLASH_UPHEALGROUPS3 = "/hg";
	SLASH_UPHEALGROUPS4 = "/healgroups";
	
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("VARIABLES_LOADED");
	this:SetBackdropColor(0, 0, 0, 1);
		
end

--/////////////////////////////////////////////////////////

function UPHealGroups_OnEvent(event)
	
	if( event == "VARIABLES_LOADED" ) then
		
		if (UPHG == nil) then
			UPHG = {
				ChannelName = 'raid',
				HealGroupNames = {},
				Healers = {},
				Classes = {
					["Druid"] = 1,
					["Hunter"] = 0,
					["Mage"] = 0,
					["Priest"] = 1,
					["Rogue"] = 0,
					["Shaman"] = 1,
					["Warlock"] = 0,
					["Warrior"] = 0,
					["Paladin"] = 1,
					["DeathKnight"] = 0
				},
			};
			
			tinsert(UPHG.HealGroupNames, UPHealGroups_CreateEmptyGroup());
			
		end
		
		UPHealGroups_Init();
		
	elseif( event == "PARTY_MEMBERS_CHANGED" or event == "RAID_ROSTER_UPDATE" ) then
	
		UPHG_initDone = false;
		UPHealGroups_Refresh();
		
	end

end

--/////////////////////////////////////////////////////////

function UPHealGroups_CreateEmptyGroup()

	local emptyGrp = 
		{
			[1] = 'Group 1',
			[2] = 'Group 2',
			[3] = 'Group 3',
			[4] = 'Group 4',
			[5] = 'Group 5',
			[6] = 'Group 6',
			[7] = 'Group 7',
			[8] = 'Group 8',
			[9] = 'Group 9',
			[10] = 'Group 10',
			[11] = 'Group 11',
			[12] = 'Group 12',
			["Name"] = "New Group"
		};

	return emptyGrp;
	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_Init()

	getglobal(UPHealGroupsClassSelectionFrameCheckButtonDruid:GetName() .. "Text"):SetText("Druid");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonHunter:GetName() .. "Text"):SetText("Hunter");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonMage:GetName() .. "Text"):SetText("Mage");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonPriest:GetName() .. "Text"):SetText("Priest");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonRogue:GetName() .. "Text"):SetText("Rogue");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonShaman:GetName() .. "Text"):SetText("Shaman");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonWarlock:GetName() .. "Text"):SetText("Warlock");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonWarrior:GetName() .. "Text"):SetText("Warrior");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonPaladin:GetName() .. "Text"):SetText("Paladin");
	getglobal(UPHealGroupsClassSelectionFrameCheckButtonDeathKnight:GetName() .. "Text"):SetText("Death Knight");
	
	UPHealGroupsClassSelectionFrameCheckButtonDruid:SetChecked(UPHG.Classes["Druid"]);
	UPHealGroupsClassSelectionFrameCheckButtonHunter:SetChecked(UPHG.Classes["Hunter"]);
	UPHealGroupsClassSelectionFrameCheckButtonMage:SetChecked(UPHG.Classes["Mage"]);
	UPHealGroupsClassSelectionFrameCheckButtonPriest:SetChecked(UPHG.Classes["Priest"]);
	UPHealGroupsClassSelectionFrameCheckButtonRogue:SetChecked(UPHG.Classes["Rogue"]);
	UPHealGroupsClassSelectionFrameCheckButtonShaman:SetChecked(UPHG.Classes["Shaman"]);
	UPHealGroupsClassSelectionFrameCheckButtonWarlock:SetChecked(UPHG.Classes["Warlock"]);
	UPHealGroupsClassSelectionFrameCheckButtonWarrior:SetChecked(UPHG.Classes["Warrior"]);
	UPHealGroupsClassSelectionFrameCheckButtonPaladin:SetChecked(UPHG.Classes["Paladin"]);
	UPHealGroupsClassSelectionFrameCheckButtonDeathKnight:SetChecked(UPHG.Classes["DeathKnight"]);

	UPHealGroupsFrame_ChannelName:SetText(UPHG.ChannelName);
	UPHealGroups_RefreshGroupNames();

end

--/////////////////////////////////////////////////////////

function UPHealGroups_RefreshGroupNames()
	for i = 1, 12, 1 do
		
		getglobal("UPHealGroups_GroupFrame" .. i .. "GroupName"):SetText(UPHG.HealGroupNames[UPHG_currentIndex][i]);
	
		if (i < 7) then
			getglobal("UPHealGroups_GroupFrame" .. i):SetPoint("TOPLEFT", ((i - 1) * 100 + i * 7), -50);
		else
			getglobal("UPHealGroups_GroupFrame" .. i):SetPoint("TOPLEFT", ((i - 7) * 100 + (i - 6) * 7), -200);
		end
		
	end	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_Refresh()

	if(not UPHG_initDone) then
		
		for name, data in pairs(UPHG.Healers) do
			data["OnRaid"] = false;
			
		end
	
		local raidMembers = UPHealGroups_GetRaidMembers();
		--local raidMembers = UPHealGroups_GetDebugRaidList();
		
		local found;
		local name;
		local class;
		
		for key, value in pairs(raidMembers) do
		
			found = false;
			name = value["Name"];
			class = value["Class"];
		
			if(UPHG.Healers[name] ~= nil) then
				found = true;
				UPHG.Healers[name]["OnRaid"] = true;
			end
			
			if (not found) then
				UPHG.Healers[name] = { ["Class"] = class, ["Group"] = {}, ["OnRaid"] = true };
			end
			
		end
		
		for name, player in pairs(UPHG.Healers) do
			if (not player["OnRaid"]) then
				UPHG.Healers[name] = nil;
			end
		end
	end
	
	local cpt = 1;
	local arrCount = {
		[1] = 0,
		[2] = 0,
		[3] = 0,
		[4] = 0,
		[5] = 0,
		[6] = 0,
		[7] = 0,
		[8] = 0,
		[9] = 0,
		[10] = 0,
		[11] = 0,
		[12] = 0,
		[-1] = 0
	};
	
	local yOffset = -3;
	local xOffset = 3;
	local playerGroupIdx;
	
	for name, info in pairs(UPHG.Healers) do
	
		if(info["OnRaid"]) then
			
			if(info["Group"][UPHG_currentIndex]) then
				playerGroupIdx = info["Group"][UPHG_currentIndex];
			else
				playerGroupIdx = -1;
			end
			
			groupCpt = arrCount[playerGroupIdx];
			
			local frame = getglobal("UPHealGroups_PlayerFrame" .. cpt);
			getglobal("UPHealGroups_PlayerFrame" .. cpt .. "PlayerName"):SetText(name);
			frame:SetBackdropColor(RAID_CLASS_COLORS[strupper(info["Class"])]["r"], RAID_CLASS_COLORS[strupper(info["Class"])]["g"], RAID_CLASS_COLORS[strupper(info["Class"])]["b"], 1);
			
			frame:ClearAllPoints();
			
			if(playerGroupIdx > -1) then
				frame:SetPoint("TOPLEFT", "UPHealGroups_GroupFrame"..info["Group"][UPHG_currentIndex], "TOPLEFT", 3, 0 - groupCpt * 20);
			else
				if(groupCpt == 7 or groupCpt == 14 or groupCpt == 21 or groupCpt == 28 or groupCpt == 35) then
					yOffset = yOffset - 21;
					xOffset = xOffset - (7*90);
				end		
				
				frame:SetPoint("TOPLEFT", "UPHealGroups_GroupFrameExtras" , "TOPLEFT", groupCpt * 90 + xOffset, yOffset);
			end
			
			frame:Show();
			arrCount[playerGroupIdx] = arrCount[playerGroupIdx] + 1;
			cpt = cpt + 1;
		
		end		
	end	
	
	for i = cpt, 40, 1 do
		getglobal("UPHealGroups_PlayerFrame" .. i):Hide();
	end

end

--/////////////////////////////////////////////////////////

function UPHealGroups_GetRaidMembers()
	
	local cpt = 0;
	local arr = {};
	
	for i = 1, 40, 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, _, _ = GetRaidRosterInfo(i);
		if (class) then
			class = gsub(class, " ", "");
	
			if(UPHG.Classes[class] == 1) then
				cpt = cpt + 1;
				arr[cpt] = { ["Name"] = name, ["Class"] = gsub(class, ' ', '') };
			end
		end
	end
	
	return arr;

end

--/////////////////////////////////////////////////////////

function UPHealGroups_DropPlayerOnGroup(frame)
	local x;
	local y;
	
	local groupLeftX;
	local groupTopY;
	local groupRightX;
	local groupBottomY;
	local groupFrame;
	local assigned = false;
	
	x, y = frame:GetCenter();
	
	for i = 1, 12, 1 do
		groupFrame = getglobal("UPHealGroups_GroupFrame" .. i);
		groupLeftX = groupFrame:GetLeft();
		groupRightX = groupFrame:GetRight();
		groupTopY = groupFrame:GetTop();
		groupBottomY = groupFrame:GetBottom();
		
		if(x > groupLeftX and x < groupRightX and y < groupTopY and y > groupBottomY) then
			UPHG.Healers[getglobal(frame:GetName().."PlayerName"):GetText()]["Group"][UPHG_currentIndex] = i;
			assigned = true;
			break;
		end
	end
	
	if(not assigned) then
		UPHG.Healers[getglobal(frame:GetName().."PlayerName"):GetText()]["Group"][UPHG_currentIndex] = nil;
	end
	
	UPHealGroups_Refresh();
end

--/////////////////////////////////////////////////////////

function UPHealGroups_SlashCommandHandler(msg)
	if( UPHealGroupsFrame:IsVisible() ) then
		HideUIPanel(UPHealGroupsFrame);
	else
		ShowUIPanel(UPHealGroupsFrame);
	end
end

--/////////////////////////////////////////////////////////

function UPHealGroups_OnShow()
	UPHealGroups_Refresh();
	
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrame_Broadcast()
	
	local arr = {
		[1] = { ["Count"] = 0, ["Names"] = '' },
		[2] = { ["Count"] = 0, ["Names"] = '' },
		[3] = { ["Count"] = 0, ["Names"] = '' },
		[4] = { ["Count"] = 0, ["Names"] = '' },
		[5] = { ["Count"] = 0, ["Names"] = '' },
		[6] = { ["Count"] = 0, ["Names"] = '' },
		[7] = { ["Count"] = 0, ["Names"] = '' },
		[8] = { ["Count"] = 0, ["Names"] = '' },
		[9] = { ["Count"] = 0, ["Names"] = '' },
		[10] = { ["Count"] = 0, ["Names"] = '' },
		[11] = { ["Count"] = 0, ["Names"] = '' },
		[12] = { ["Count"] = 0, ["Names"] = '' }
	};
	
	local arrLd = {};
	-- do a check to see if a player is offline / linkdead
	for i = 1, 40, 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		
		if(name ~= nil) then
			if(online == nil) then
				arrLd[name] = 0;
			else
				arrLd[name] = 1;
			end
		end		
	end
	
	for name, data in pairs(UPHG.Healers) do
	
		if(data["OnRaid"] and data["Group"][UPHG_currentIndex] and data["Group"][UPHG_currentIndex] > -1) then
		
			if(arr[data["Group"][UPHG_currentIndex]]["Count"] > 0) then
				arr[data["Group"][UPHG_currentIndex]]["Names"] = arr[data["Group"][UPHG_currentIndex]]["Names"]..', ';
			end
			arr[data["Group"][UPHG_currentIndex]]["Names"] = arr[data["Group"][UPHG_currentIndex]]["Names"]..name;
			if(arrLd[name] == 0) then
				-- add the offline warning for a player
				arr[data["Group"][UPHG_currentIndex]]["Names"] = arr[data["Group"][UPHG_currentIndex]]["Names"]..'[OFFLINE]';
			end
			arr[data["Group"][UPHG_currentIndex]]["Count"] = arr[data["Group"][UPHG_currentIndex]]["Count"] + 1;
			
		end
	end
	
	UPHealGroupsFrame_SendToChat('-- Assignments for ' .. UPHG.HealGroupNames[UPHG_currentIndex]["Name"] .. ' --');
	
	for i = 1, 12, 1 do
	
		if(arr[i]["Count"] > 0) then
			UPHealGroupsFrame_SendToChat(UPHG.HealGroupNames[UPHG_currentIndex][i]..': '..arr[i]["Names"]);
		end
	
	end
	
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrame_SendToChat(str)
	if(strlower(UPHG.ChannelName) == 'raid') then
		SendChatMessage(str, "RAID");
	elseif(strlower(UPHG.ChannelName) == 'party') then
		SendChatMessage(str, "PARTY");
	elseif(strlower(UPHG.ChannelName) == 'guild') then
		SendChatMessage(str, "GUILD");
	elseif(strlower(UPHG.ChannelName) == 'officer') then
		SendChatMessage(str, "OFFICER");
	elseif(strlower(UPHG.ChannelName) == 'yell') then
		SendChatMessage(str, "YELL");
	elseif(strlower(UPHG.ChannelName) == 'emote') then
		SendChatMessage(str, "EMOTE");
	elseif(strlower(UPHG.ChannelName) == 'say') then
		SendChatMessage(str, "SAY");
	elseif(strlower(UPHG.ChannelName) == 'raidwarning' or strlower(UPHG.ChannelName) == 'rw') then
		SendChatMessage(str, "RAID_WARNING");
	else
		SendChatMessage(str, "CHANNEL", nil, GetChannelName(UPHG.ChannelName));
	end
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrame_Debug(str)
	DEFAULT_CHAT_FRAME:AddMessage('[UPHealGroups]DEBUG: '..str);
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrameDropDown_Initialize()

	for i = 1, #(UPHG.HealGroupNames), 1 do
		local info = UIDropDownMenu_CreateInfo();
		info.text = UPHG.HealGroupNames[i]["Name"];
		info.func = function() UPHealGroupsFrameDropDown_OnClick(i) end;
		info.owner = UPHealGroupsFrameDropDown;

		UIDropDownMenu_AddButton(info, 1);
	end
	
	UIDropDownMenu_SetSelectedID(UPHealGroupsFrameDropDown, UPHG_currentIndex);
	
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrameDropDown_OnClick(i)
	UIDropDownMenu_SetSelectedID(UPHealGroupsFrameDropDown, i);
	UPHG_currentIndex = i;
	UPHealGroups_RefreshGroupNames();
	UPHealGroups_Refresh();
end

--/////////////////////////////////////////////////////////

function UPHealGroupsFrameDropDown_OnShow()
	UIDropDownMenu_Initialize(UPHealGroupsFrameDropDown, UPHealGroupsFrameDropDown_Initialize);
	UIDropDownMenu_SetWidth(UPHealGroupsFrameDropDown, 175);
end

--/////////////////////////////////////////////////////////

function UPHealGroups_TextEdit_OnShow()
	UPHealGroups_EditFrameNoteEB:SetText('');
end

--/////////////////////////////////////////////////////////

function UPHealGroups_DelGroup()
	if(UPHG_currentIndex <= 1) then
		message("Cannot delete the first entry");
	else		
		for i = UPHG_currentIndex, #(UPHG.HealGroupNames) - 1, 1 do
			for name, player in pairs(UPHG.HealGroupNames) do
				player["Group"][i] = player["Group"][i + 1];
				player["Group"][#(UPHG.HealGroupNames)] = nil;
			end
			UPHG.HealGroupNames[i] = UPHG.HealGroupNames[i+1];
		end
		
		tremove(UPHG.HealGroupNames);
		
		UPHG_currentIndex = UPHG_currentIndex - 1;
		UIDropDownMenu_SetText(UPHealGroupsFrameDropDown, UPHG.HealGroupNames[UPHG_currentIndex]["Name"]);
		UPHealGroups_RefreshGroupNames();
		UPHealGroups_Refresh();
	end
end

--/////////////////////////////////////////////////////////

function UPHealGroups_ResetGroup()
	for name, player in pairs(UPHG.Healers) do
		player["Group"][UPHG_currentIndex] = nil;
	end
	UPHealGroups_Refresh();
	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_ClassSelect()
	UPHealGroupsClassSelectionFrame:Show();

end

--/////////////////////////////////////////////////////////

function UPHealGroups_SaveClasses()

	UPHG.Classes["Druid"] = UPHealGroupsClassSelectionFrameCheckButtonDruid:GetChecked();
	UPHG.Classes["Hunter"] = UPHealGroupsClassSelectionFrameCheckButtonHunter:GetChecked();
	UPHG.Classes["Mage"] = UPHealGroupsClassSelectionFrameCheckButtonMage:GetChecked();
	UPHG.Classes["Priest"] = UPHealGroupsClassSelectionFrameCheckButtonPriest:GetChecked();
	UPHG.Classes["Rogue"] = UPHealGroupsClassSelectionFrameCheckButtonRogue:GetChecked();
	UPHG.Classes["Shaman"] = UPHealGroupsClassSelectionFrameCheckButtonShaman:GetChecked();
	UPHG.Classes["Warlock"] = UPHealGroupsClassSelectionFrameCheckButtonWarlock:GetChecked();
	UPHG.Classes["Warrior"] = UPHealGroupsClassSelectionFrameCheckButtonWarrior:GetChecked();
	UPHG.Classes["Paladin"] = UPHealGroupsClassSelectionFrameCheckButtonPaladin:GetChecked();
	UPHG.Classes["DeathKnight"] = UPHealGroupsClassSelectionFrameCheckButtonDeathKnight:GetChecked();
	
	UPHealGroupsClassSelectionFrame:Hide();
	UPHealGroups_Refresh();	

end

--/////////////////////////////////////////////////////////

function UPHealGroups_AddGroup()

	local i = #(UPHG.HealGroupNames) + 1;
	
	tinsert(UPHG.HealGroupNames, UPHealGroups_CreateEmptyGroup());

	local info = UIDropDownMenu_CreateInfo();
	info.text = UPHG.HealGroupNames[i]["Name"];
	info.func = function() UPHealGroupsFrameDropDown_OnClick(i) end;
	info.parent = UPHealGroupsFrameDropDown;
	
	UIDropDownMenu_AddButton(info, 1);
	
	UPHG_currentIndex = i;
	UPHealGroups_RefreshGroupNames();
	UPHealGroups_Refresh();
	UIDropDownMenu_SetSelectedID(UPHealGroupsFrameDropDown, UPHG_currentIndex);	
	UPHealGroups_RenameGroup();

end

--/////////////////////////////////////////////////////////

function UPHealGroups_RenameGroup()
	UPHealGroups_EditFrameEditing:SetText('Enter new group set name:');
	UPHealGroups_EditFrame.edit = 'GroupSetNameEdit';
	UPHealGroups_EditFrame:Show();
	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_EditChannelName()
	UPHealGroups_EditFrameEditing:SetText('Enter new channel name:');
	UPHealGroups_EditFrame.edit = 'ChannelNameEdit';
	UPHealGroups_EditFrame:Show();
	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_TextSave()

	if (UPHealGroups_EditFrame.edit == 'ChannelNameEdit') then
	
		if (UPHealGroups_EditFrameNoteEB:GetText() ~= '') then
			
			UPHealGroupsFrame_ChannelName:SetText(UPHealGroups_EditFrameNoteEB:GetText());
			UPHG.ChannelName = UPHealGroups_EditFrameNoteEB:GetText();
				
		end
		
	elseif (UPHealGroups_EditFrame.edit == 'GroupNameEdit') then
	
		local i = UPHealGroups_EditFrame.gid;
		
		UPHG.HealGroupNames[UPHG_currentIndex][i] = UPHealGroups_EditFrameNoteEB:GetText();
		getglobal("UPHealGroups_GroupFrame" .. i .. "GroupName"):SetText(UPHG.HealGroupNames[UPHG_currentIndex][i]);
			
	elseif (UPHealGroups_EditFrame.edit == 'GroupSetNameEdit') then
	
		UPHG.HealGroupNames[UPHG_currentIndex]["Name"] = UPHealGroups_EditFrameNoteEB:GetText();
		UIDropDownMenu_SetText(UPHealGroupsFrameDropDown, UPHealGroups_EditFrameNoteEB:GetText());
			
	end
	
	UPHealGroups_EditFrame:Hide();
		
end

--/////////////////////////////////////////////////////////

function UPHealGroups_EditGroupName(id)

	UPHealGroups_EditFrameEditing:SetText('Enter new group name:');
	UPHealGroups_EditFrame.edit = 'GroupNameEdit';
	UPHealGroups_EditFrame.gid = id;
	UPHealGroups_EditFrame:Show();
	
end

--/////////////////////////////////////////////////////////

function UPHealGroups_GetDebugRaidList()

	local arr = {};

	arr[0] = { ["Name"] = 'Priest1', ["Class"] = 'Priest' };
	arr[1] = { ["Name"] = 'Shaman1', ["Class"] = 'Shaman' };
	arr[2] = { ["Name"] = 'Druid1', ["Class"] = 'Druid' };
	arr[3] = { ["Name"] = 'Warrior1', ["Class"] = 'Warrior' };
	arr[4] = { ["Name"] = 'Mage1', ["Class"] = 'Mage' };
	arr[5] = { ["Name"] = 'Priest2', ["Class"] = 'Priest' };
	arr[6] = { ["Name"] = 'Mage2', ["Class"] = 'Mage' };
	arr[7] = { ["Name"] = 'Shaman2', ["Class"] = 'Shaman' };
	arr[8] = { ["Name"] = 'Warrior2', ["Class"] = 'Warrior' };
	arr[9] = { ["Name"] = 'Priest3', ["Class"] = 'Priest' };
	arr[10] = { ["Name"] = 'Shaman3', ["Class"] = 'Shaman' };
	arr[11] = { ["Name"] = 'Druid2', ["Class"] = 'Druid' };
	arr[12] = { ["Name"] = 'Hunter1', ["Class"] = 'Hunter1' };
	arr[13] = { ["Name"] = 'Mage3', ["Class"] = 'Mage' };
	arr[14] = { ["Name"] = 'Priest4', ["Class"] = 'Priest' };
	arr[15] = { ["Name"] = 'Mage4', ["Class"] = 'Mage' };
	arr[16] = { ["Name"] = 'Shaman4', ["Class"] = 'Shaman' };
	arr[17] = { ["Name"] = 'Warrior4', ["Class"] = 'Warrior' };
	arr[18] = { ["Name"] = 'Paladin1', ["Class"] = 'Paladin' };
	arr[19] = { ["Name"] = 'Shaman5', ["Class"] = 'Shaman' };
	arr[20] = { ["Name"] = 'Druid3', ["Class"] = 'Druid' };
	arr[21] = { ["Name"] = 'Rogue1', ["Class"] = 'Rogue' };
	arr[22] = { ["Name"] = 'Warlock1', ["Class"] = 'Warlock' };
	arr[23] = { ["Name"] = 'Paladin2', ["Class"] = 'Paladin' };
	arr[24] = { ["Name"] = 'DeathKnight1', ["Class"] = 'DeathKnight' };
	
	return arr;

end